--------------------------------------------------------------[[ Wilmatron, GDI Final Mission 15EA ]]
-- [[ Pre-World Build ]]
--
Camera.Position = DefaultCameraPosition.CenterPosition
Test = { FTank }
--
--Declare initial GDI reinforcements
InitialGDIForcesA = { "mcv" }
InitialGDIForcesB = { "mtnk" }
--
--Declare NOD Starting cash
NODStartingCash = 10000
--
--Declare NOD Base - Starting Actors
NODBase = { NODConYard1, NODHand1, NODHand2, NODAirF1, NODAirF2, NODProc1, NODProc2, NODProc3 }
--
--Declare NOD structures eligable for re-build
BaseHand1 = { type = "hand", pos = CPos.New(29, 34), cost = 500, exists = true }
BaseHand2 = { type = "hand", pos = CPos.New(44, 48), cost = 500, exists = true }
BaseAirF1 = { type = "afld", pos = CPos.New(27, 40), cost = 2000, exists = true }
BaseAirF2 = { type = "afld", pos = CPos.New(42, 54), cost = 2000, exists = true }
BaseProc1 = { type = "proc", pos = CPos.New(38, 33), cost = 1500, exists = true }
BaseProc2 = { type = "proc", pos = CPos.New(41, 49), cost = 1500, exists = true }
BaseProc3 = { type = "proc", pos = CPos.New(54, 48), cost = 1500, exists = true }
NODBaseBuildings = { BaseHand1, BaseHand2, BaseAirF1, BaseAirF2, BaseProc1, BaseProc2, BaseProc3 }
--
--Declare all NOD SAM sites
NODSams = { Sam01, Sam02, Sam03, Sam04, Sam05 }
--
--Declare NOD attack forces (for wave attacks)
NODAttackWave1 = { barracks = NODHand2, types = { "e1", "e1", "e1", "e1", "e3", "e3" }, factory = { }, vehicles = { } }
NODAttackWave2 = { barracks = NODHand2, types = { "e4", "e4" }, factory = NODAirF2, vehicles = { "bggy" } }
NODAttackWave3 = { barracks = NODHand1, types = { "e3", "e3", "e4", "e4" }, factory = { }, vehicles = { } }
NODAttackWave4 = { barracks = NODHand1, types = { "e3", "e3" }, factory = NODAirF1, vehicles = { "ltnk" } }
NODAttackWave5 = { barracks = NODHand1, types = { "e1", "e1", "e1" }, factory = NODAirF1, vehicles = { "arty" } }
--
--Declare NOD attack routes (for wave attacks)
NODAttackRoute1 = { waypoint0.Location, waypoint1.Location, waypoint2.Location, waypoint3.Location, waypoint4.Location }
NODAttackRoute2 = { waypoint0.Location, waypoint1.Location, waypoint10.Location}
NODAttackRoute3 = { waypoint1.Location, waypoint10.Location}
NODAttackRoute4 = { waypoint1.Location, waypoint2.Location, waypoint3.Location, waypoint4.Location }
--
NODAttackingForces = {                                                                              --Declare NOD random attacking forces
		{ barracks = NODHand1, types = { "e1", "e1", "e1", "e2", "e2" }, factory = { }, vehicles = { } },
    { barracks = NODHand1, types = { "e3", "e3", "e3", "e4", "e4" }, factory = { }, vehicles = { } },
    { barracks = { }, types = { }, factory = NODAirF1, vehicles = { "bggy", "bggy" } },
    { barracks = NODHand1, types = { "e4", "e4" }, factory = NODAirF1, vehicles = { "bggy" } },
    { barracks = NODHand1, types = { "e3", "e3" }, factory = NODAirF1, vehicles = { "ltnk" } },
    { barracks = NODHand1, types = { "e1", "e1" }, factory = NODAirF1, vehicles = { "ltnk", "ltnk" } },
    { barracks = NODHand1, types = { "e4", "e4" }, factory = NODAirF1, vehicles = { "stnk" } },
    { barracks = { }, types = { }, factory = NODAirF1, vehicles = { "stnk", "stnk" } },
    { barracks = NODHand1, types = { "e3", "e3" }, factory = NODAirF1, vehicles = { "ftnk" } }
}

NODAttackRoutes = {                                                                                 --Declare NOD random attack routes
    { waypoint1.Location, waypoint10.Location},
    { waypoint1.Location, waypoint2.Location, waypoint3.Location, waypoint4.Location }
  }

BuildFromFactory = function(factory, units, action)                                                 --Declare factory build function
	if factory.IsDead or factory.Owner ~= enemy then
		return
	end

	if not factory.Build(units, action) then
		Trigger.AfterDelay(DateTime.Seconds(2), function()
			BuildFromFactory(factory, units, action)
		end)
	end
end

BuildFromBarracks = function(barracks, units, action)                                               --Declare barracks build function
	if barracks.IsDead or barracks.Owner ~= enemy then
		return
	end
  
  if not barracks.Build(units, action) then
		Trigger.AfterDelay(DateTime.Seconds(2), function()
			BuildFromBarracks(barracks, units, action)
		end)
	end
end

--
--Declare Functions
--
SendInitialGDIForcesA = function()                                                                  -- Send initial GDI reinforcements, MCV
	Media.PlaySpeechNotification(player, "Reinforce")
	Reinforcements.Reinforce(player, InitialGDIForcesA, { InitForces.Location, waypoint13.Location }, 5)
end
SendInitialGDIForcesB = function()                                                                  -- Send initial GDI reinforcements, M.Tank
  Media.PlaySpeechNotification(player, "Reinforce")
	Reinforcements.Reinforce(player, InitialGDIForcesB, { InitForces.Location, waypoint13.Location }, 15)
end

--
StartAI = function(cyard)                                                                           -- Start AI
    Utils.Do(Map.NamedActors, function(actor)                                                       -- If enemy structure is damaged beyond 50% of max health then repair building
      if actor.Owner == enemy and actor.HasProperty("StartBuildingRepairs") then
        Trigger.OnDamaged(actor, function(building)
          if building.Owner == enemy and building.Health < 0.5 * building.MaxHealth then
            building.StartBuildingRepairs()
          end
        end)
      end
    end)
  enemy.Cash = NODStartingCash                                                                      -- Give NOD their cash!
  BuildBase(cyard)                                                                                  -- Structure rebuild logic
end
--
BuildBase = function(cyard)
	Utils.Do(NODBaseBuildings, function(building)
		if not building.exists and not cyardIsBuilding then
			BuildBuilding(building, cyard)
			return
		end
	end)
	Trigger.AfterDelay(DateTime.Seconds(10), function() BuildBase(cyard) end)
end

BuildBuilding = function(building, cyard)
	cyardIsBuilding = true

	Trigger.AfterDelay(Actor.BuildTime(building.type), function()
		cyardIsBuilding = false

		if cyard.IsDead or cyard.Owner ~= enemy then
			return
		end

		local actor = Actor.Create(building.type, true, { Owner = enemy, Location = building.pos })
		enemy.Cash = enemy.Cash - building.cost

		building.exists = true

		--if actor.Type == 'pyle' or actor.Type == 'hand' then
		--	Trigger.AfterDelay(DateTime.Seconds(10), function() ProduceInfantry(actor) end)
		--elseif actor.Type == 'weap' or actor.Type == 'afld' then
		--	Trigger.AfterDelay(DateTime.Seconds(10), function() ProduceVehicle(actor) end)
		--end

		Trigger.OnKilled(actor, function() building.exists = false end)

		Trigger.OnDamaged(actor, function(building)
			if building.Owner == enemy and building.Health < building.MaxHealth * 3/4 then
				building.StartBuildingRepairs()
			end
		end)

		Trigger.AfterDelay(DateTime.Seconds(10), function() BuildBase(cyard) end)
	end)
end
--
FlameTankHarass = function()                                                                        -- Harassing flame tank and attacking strategy
  local InitialNODFlameTank = FTank
  InitialNODFlameTank.Wait(150)
  InitialNODFlameTank.AttackMove(waypoint4.Location)
  InitialNODFlameTank.Wait(100)
  InitialNODFlameTank.AttackMove(waypoint13.Location)
end

NODTankPatrol = function()                                                                          -- NOD Tank Patrol units, plus patrol routes
  local NODTankPatrolUnit1 = LTank1
  local NODTankPatrolUnit2 = LTank2
  local NODTankPath = { waypoint1.Location, waypoint2.Location, waypoint8.Location, waypoint2.Location, waypoint1.Location, waypoint5.Location, waypoint9.Location, waypoint5.Location}
  NODTankPatrolUnit1.Wait(125)
  NODTankPatrolUnit1.Patrol(NODTankPath, true, 100)
  NODTankPatrolUnit2.Wait(125)
  NODTankPatrolUnit2.Patrol(NODTankPath, true, 100)
end

RebuildWave1 = function()                                                                           -- Should all of NOD Wave 1 attacking force be destroyed, rebuild them
  local production = NODAttackWave1
  BuildFromBarracks(production.barracks, production.types, function(units)
  end)
end
RebuildWave3 = function()                                                                           -- Should all of NOD Wave 3 attacking force be destroyed, rebuild them
  local production = NODAttackWave3
  BuildFromBarracks(production.barracks, production.types, function(units)
  end)
end
AttackPlayerWave1 = function()                                                                      -- NOD Wave 1 attacking force, plus attacking strategy - update
  local production = NODAttackWave1 
	local path = NODAttackRoute1
	BuildFromFactory(production.factory, production.vehicles, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  BuildFromBarracks(production.barracks, production.types, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
  Trigger.OnAllKilled(units, RebuildWave1)
	end)
end
AttackPlayerWave2 = function()                                                                      -- NOD Wave 2 attacking force, plus attacking strategy
  local production = NODAttackWave2 
	local path = NODAttackRoute2
	BuildFromFactory(production.factory, production.vehicles, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  BuildFromBarracks(production.barracks, production.types, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
end
AttackPlayerWave3 = function()                                                                      -- NOD Wave 3 attacking force, plus attacking strategy
 local production = NODAttackWave3 
	local path = NODAttackRoute3
	BuildFromFactory(production.factory, production.vehicles, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  BuildFromBarracks(production.barracks, production.types, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
  Trigger.OnAllKilled(units, RebuildWave3)
	end)
end 

AttackPlayerWave4 = function()                                                                      -- NOD Wave 4 attacking force, plus attacking strategy
  local production = NODAttackWave4 
	local path = NODAttackRoute4
	BuildFromFactory(production.factory, production.vehicles, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  BuildFromBarracks(production.barracks, production.types, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
end
AttackPlayerWave5 = function()                                                                      -- NOD Wave 5 attacking force, plus attacking strategy
  local production = NODAttackWave5 
	local path = NODAttackRoute4
	BuildFromFactory(production.factory, production.vehicles, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  BuildFromBarracks(production.barracks, production.types, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
end
AttackPlayerRandom = function()                                                                     -- NOD Random attacking force, plus attacking strategy, loop every 2 minutes
  local production = Utils.Random(NODAttackingForces) 
	local path = Utils.Random(NODAttackRoutes)
	BuildFromFactory(production.factory, production.vehicles, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  BuildFromBarracks(production.barracks, production.types, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  Trigger.AfterDelay(DateTime.Seconds(90), AttackPlayerRandom)
end

--
WorldLoaded = function()                                                                            -- When the world has loaded perform the following within...
  --
	player = Player.GetPlayer("GDI")                                                                  -- Define player as GDI forces
	enemy = Player.GetPlayer("Nod")                                                                   -- Define enemy as NOD forces
	villagers = Player.GetPlayer("Villagers")                                                         -- Define villagers as villagers
  --
  StartAI(NODConYard1)                                                                              -- Initiate the enemy AI
  --
	Trigger.OnObjectiveAdded(player, function(p, id)                                                  -- When adding an objective display message
		Media.DisplayMessage(p.GetObjectiveDescription(id), "New " .. string.lower(p.GetObjectiveType(id)) .. " objective")
	end)
	Trigger.OnObjectiveCompleted(player, function(p, id)                                              -- When completing an objective display message
		Media.DisplayMessage(p.GetObjectiveDescription(id), "Objective completed")
	end)
	Trigger.OnObjectiveFailed(player, function(p, id)                                                 -- When failing an objective display message
		Media.DisplayMessage(p.GetObjectiveDescription(id), "Objective failed")
	end)

	
  Trigger.OnPlayerWon(player, function()                                                            -- When player wins the mission play a speech notification "Win"
		Media.PlaySpeechNotification(player, "Win")
	end)

	Trigger.OnPlayerLost(player, function()                                                           -- When player loses the mission play a speech notification "Lose"
		Media.PlaySpeechNotification(player, "Lose")
	end)
  
  --
  GDIObjective1 = player.AddPrimaryObjective("Destroy the NOD stronghold.")                         -- Create Primary Objective for the player
  GDIObjective2 = player.AddSecondaryObjective("Destroy the SAM sites to receive air support.")     -- Create Secondary Objective for the player
  NodObjective1 = enemy.AddPrimaryObjective("Eliminate all GDI forces.")                            -- Create Primary Objective for the enemy
  --
  SendInitialGDIForcesA()                                                                           -- Spawn GDI MCV to map
  Trigger.AfterDelay(DateTime.Seconds(6), SendInitialGDIForcesB)                                    -- Spawn GDI Med Tank to map, 6 seconds after the MVC unit arrives
  FlameTankHarass()                                                                                 -- Harass GDI with flame tank
  NODTankPatrol()                                                                                   -- Initiate NOD Tank Patrol
  --
  Trigger.AfterDelay(DateTime.Seconds(1), AttackPlayerWave1)                                        -- Build a new team to attack GDI after 90 seconds of game time, NOD Wave 1
  Trigger.AfterDelay(DateTime.Seconds(120), AttackPlayerWave2)                                      -- Build a new team to attack GDI after 95 seconds of game time, NOD Wave 2
  Trigger.AfterDelay(DateTime.Seconds(180), AttackPlayerWave3)                                      -- Build a new team to attack GDI after 150 seconds of game time, NOD Wave 3
  Trigger.AfterDelay(DateTime.Seconds(210), AttackPlayerWave4)                                      -- Build a new team to attack GDI after 155 seconds of game time, NOD Wave 4
  Trigger.AfterDelay(DateTime.Seconds(250), AttackPlayerWave5)                                      -- Build a new team to attack GDI after 180 seconds of game time, NOD Wave 5
  Trigger.AfterDelay(DateTime.Seconds(320), AttackPlayerRandom)                                     -- Build a random new team to attack GDI after X seconds of game time
  --
  Trigger.OnAllKilled(NODSams, function()                                                           -- When all NOD SAM Sites are destroyed, unlock airstrikes for GDI
		player.MarkCompletedObjective(GDIObjective2)
    Media.PlaySpeechNotification(player, "AirstrikeReady")
		Actor.Create("airstrike.proxy", true, { Owner = player })
	end)
  Trigger.OnDamaged(NODTemple, function()                                                           -- If the Temple of NOD is attacked, have NOD launch a nuclear warhead
    Media.PlaySpeechNotification(player, "NuclearWeaponLaunched")
  end)
  --
  Trigger.OnKilled(NODProc1, function(building)                                                     -- If NOD Structure is destroyed, flag to the AI that it needs to be rebuilt
	BaseProc1.exists = false
  end)

  Trigger.OnKilled(NODProc2, function(building)                                                     -- If NOD Structure is destroyed, flag to the AI that it needs to be rebuilt
	BaseProc2.exists = false
  end)

  Trigger.OnKilled(NODProc3, function(building)                                                     -- If NOD Structure is destroyed, flag to the AI that it needs to be rebuilt
	BaseProc3.exists = false
  end)

  Trigger.OnKilled(NODHand1, function(building)                                                     -- If NOD Structure is destroyed, flag to the AI that it needs to be rebuilt
	BaseHand1.exists = false
  end)

  Trigger.OnKilled(NODHand2, function(building)                                                     -- If NOD Structure is destroyed, flag to the AI that it needs to be rebuilt
	BaseHand2.exists = false
  end)

  Trigger.OnKilled(NODAirF1, function(building)                                                     -- If NOD Structure is destroyed, flag to the AI that it needs to be rebuilt
	BaseAirF1.exists = false
  end)

  Trigger.OnKilled(NODAirF2, function(building)                                                     -- If NOD Structure is destroyed, flag to the AI that it needs to be rebuilt
	BaseAirF2.exists = false
  end)
  
  --
  Trigger.OnAllKilledOrCaptured(NODBase, function()                                                 -- If all NOD main buildings have been destroyed send all remaining NOD units to hunt
    local list = enemy.GetGroundAttackers()
    Utils.Do(list, function(unit)
		IdleHunt(unit)
    end)
  end)
  IdleHunt = function(unit)
    if not unit.IsDead then
      Trigger.OnIdle(unit, unit.Hunt)
    end
  end
  --
end
--
Tick = function()                                                                                   -- Continually check if all GDI or NOD units destroyed, then update mission objective 1
	if DateTime.GameTime > 2 then
		if player.HasNoRequiredUnits() then
			enemy.MarkCompletedObjective(NodObjective1)
		end
		if enemy.HasNoRequiredUnits() then
			player.MarkCompletedObjective(GDIObjective1)
		end
	end
end